// Adapted from blackbox window manager by Brad Hughes
// http://blackbox.alug.org 
//
#ifndef _graphics_hh
#define _graphics_hh

typedef struct _Color {
  int r, 
    g,
    b;
} Color;

class Image {

private:
	int depth;
	unsigned long *data;
	unsigned int width, height;
	
	Color bg_color;  
	Color bc_default;
  
	XColor *colors_8bpp;
  
	// For tiling a pixmap to a window background
	Pixmap tile_pix;
	GC tile_gc;
	XGCValues tile_gcv;
  
public:
	Image();
	Image(unsigned int, unsigned int, int, const Color &);
	~Image();
  
	XImage *convertToXImage(Display *, Visual *);
	Pixmap convertToPixmap(Display *, Visual *, Window);
	unsigned long convertToPixel(const Color &);
	const Color &convertToColor(unsigned long);

	void setBackgroundColor(const Color &);
	void setBackgroundColor(unsigned char, unsigned char, unsigned char);
	void renderBevel(void);
	void invertImage(void);
	void renderHGradient(const Color &from, const Color &to);
	void renderVGradient(const Color &from, const Color &to);

	void setWidth(unsigned int w) { width=w; }
	void setHeight(unsigned int h) { height=h; }
	
	unsigned int getWidth() const { return width; }
	unsigned int getHeight() const { return height; }

	void setColorDepth(int d) { depth=d; }
	int getColorDepth() const { return depth; }

	void createImage();
	
	//int image(char **data); 
};


#endif
