// misc.cc
//
// Frank Hale 
// frankhale@yahoo.com
#include "sapphire.hh"

void signalhandler(int i) {
  static int re_enter = 0;
  
  fprintf(stderr, "%s: toplevel:\n\t[ signal %d caught ]\n", __FILE__, i);
  if (! re_enter) {
    re_enter = 1;  
    fprintf(stderr, "\t[ shutting down ]\n");
    wm->quit_nicely();
  }

  fprintf(stderr, "\t[ exiting ]\n");
  abort();
}

void err(char *fmt, ...)
{
	va_list argp;

	fprintf(stderr, "%s: ", windowmanager_name);
	va_start(argp, fmt);
	vfprintf(stderr, fmt, argp);
	va_end(argp);
	fprintf(stderr, "\n");
}

int handle_xerror(Display *dpy, XErrorEvent *e)
{
	if (e->error_code == BadAccess && e->resourceid == wm->getRootWindow()) {
		err("root window unavailible (maybe another wm is running?)");
		exit(1);
	}
#ifdef DEBUG
	else {
		char msg[80];
		XGetErrorText(dpy, e->error_code, msg, sizeof(msg));
		err("X error (%#x): %s", e->resourceid, msg);
	}
#endif
	return 0;
}

