#ifndef _TOOLBAR_HH_
#define _TOOLBAR_HH_

class Toolbar 
{
private: /* variables */
	Image ToolBarImage;
	Image ButtonImage;
	Image ClockImage;

	Pixmap frame_pix;
	Pixmap clock_pix;
	Pixmap button_pix;

	struct frame {
		Window window;
		int x,y;
		unsigned int width,height;
	} frame;
	
	struct button {
		Window window;
		int x,y;
		bool state;
		unsigned int width,height;
	} Button;

	int font_width;

	button clock;
	button close;
	button cycleUp;
	button cycleDown;
	
	char *month_abbreviation[12];

public: /* member functions */

	Toolbar();
	~Toolbar();

	void reconfigure();
	void do_button_press_event(XButtonEvent *e);
	void do_button_release_event(XButtonEvent *e);
	void redraw(bool state);
	void handle_expose_event(XExposeEvent *e);
	void checkClock(bool redraw=False);
	
	void hideToolbar();
	void showToolbar();
	
private:
	void createToolBarImage();
	void createButtonImage();
	void createClockImage();	
};

#endif
